namespace VSNUnit2k3

{

	using System;

	using Microsoft.Office.Core;

	using Extensibility;

	using System.Collections;

	using System.Runtime.InteropServices;

	using EnvDTE;



	#region Read me for Add-in installation and setup information.

	// When run, the Add-in wizard prepared the registry for the Add-in.

	// At a later time, if the Add-in becomes unavailable for reasons such as:

	//   1) You moved this project to a computer other than which is was originally created on.

	//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.

	//   3) Registry corruption.

	// you will need to re-register the Add-in by building the MyAddin21Setup project 

	// by right clicking the project in the Solution Explorer, then choosing install.

	#endregion

	

	/// <summary>

	///   The object for implementing an Add-in.

	/// </summary>

	/// <seealso class='IDTExtensibility2' />

	[GuidAttribute("B888E857-9FBF-419F-9C11-CB0C281AFD1A"), ProgId("VSNUnit2k3.Connect")]

	public class Connect : Object, Extensibility.IDTExtensibility2, IDTCommandTarget

	{

		/// <summary>

		///		Implements the constructor for the Add-in object.

		///		Place your initialization code within this method.

		/// </summary>

		public Connect()

		{

		}



		/// <summary>

		///      Implements the OnConnection method of the IDTExtensibility2 interface.

		///      Receives notification that the Add-in is being loaded.

		/// </summary>

		/// <param term='application'>

		///      Root object of the host application.

		/// </param>

		/// <param term='connectMode'>

		///      Describes how the Add-in is being loaded.

		/// </param>

		/// <param term='addInInst'>

		///      Object representing this Add-in.

		/// </param>

		/// <seealso class='IDTExtensibility2' />

		public void OnConnection(object application, Extensibility.ext_ConnectMode connectMode, object addInInst, ref System.Array custom)

		{

			

			applicationObject = (_DTE)application;

			addInInstance = (AddIn)addInInst;



			//if(connectMode == Extensibility.ext_ConnectMode.ext_cm_UISetup)

			//{

				object []contextGUIDS = new object[] { };

				Commands commands = applicationObject.Commands;

				_CommandBars commandBars = applicationObject.CommandBars;



				// When run, the Add-in wizard prepared the registry for the Add-in.

				// At a later time, the Add-in or its commands may become unavailable for reasons such as:

				//   1) You moved this project to a computer other than which is was originally created on.

				//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.

				//   3) You add new commands or modify commands already defined.

				// You will need to re-register the Add-in by building the VSNUnit2k3Setup project,

				// right-clicking the project in the Solution Explorer, and then choosing install.

				// Alternatively, you could execute the ReCreateCommands.reg file the Add-in Wizard generated in

				// the project directory, or run 'devenv /setup' from a command prompt.

				try

				{

					Command command = commands.AddNamedCommand(addInInstance, "VSNUnit2k3", "VSNUnit", "Executes the command for VSNUnit2k3", true, 352, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);

					CommandBar commandBar = (CommandBar)commandBars["Tools"];

					CommandBarControl commandBarControl = command.AddControl(commandBar, 1);

				}

				catch(System.Exception /*e*/)

				{

				}
		//	LoadVSNUnitAddin(false);

		}



		/// <summary>

		///     Implements the OnDisconnection method of the IDTExtensibility2 interface.

		///     Receives notification that the Add-in is being unloaded.

		/// </summary>

		/// <param term='disconnectMode'>

		///      Describes how the Add-in is being unloaded.

		/// </param>

		/// <param term='custom'>

		///      Array of parameters that are host application specific.

		/// </param>

		/// <seealso class='IDTExtensibility2' />

		public void OnDisconnection(Extensibility.ext_DisconnectMode disconnectMode, ref System.Array custom)

		{
	
		}



		/// <summary>

		///      Implements the OnAddInsUpdate method of the IDTExtensibility2 interface.

		///      Receives notification that the collection of Add-ins has changed.

		/// </summary>

		/// <param term='custom'>

		///      Array of parameters that are host application specific.

		/// </param>

		/// <seealso class='IDTExtensibility2' />

		public void OnAddInsUpdate(ref System.Array custom)

		{
			
		}



		/// <summary>

		///      Implements the OnStartupComplete method of the IDTExtensibility2 interface.

		///      Receives notification that the host application has completed loading.

		/// </summary>

		/// <param term='custom'>

		///      Array of parameters that are host application specific.

		/// </param>

		/// <seealso class='IDTExtensibility2' />

		public void OnStartupComplete(ref System.Array custom)

		{

		}



		/// <summary>

		///      Implements the OnBeginShutdown method of the IDTExtensibility2 interface.

		///      Receives notification that the host application is being unloaded.

		/// </summary>

		/// <param term='custom'>

		///      Array of parameters that are host application specific.

		/// </param>

		/// <seealso class='IDTExtensibility2' />

		public void OnBeginShutdown(ref System.Array custom)

		{
			SaveMyConfig();
//			if(windowToolWindow != null && Frame != null){
//				Frame.LinkedWindows.Remove(windowToolWindow);
//			}
		}

		

		/// <summary>

		///      Implements the QueryStatus method of the IDTCommandTarget interface.

		///      This is called when the command's availability is updated

		/// </summary>

		/// <param term='commandName'>

		///		The name of the command to determine state for.

		/// </param>

		/// <param term='neededText'>

		///		Text that is needed for the command.

		/// </param>

		/// <param term='status'>

		///		The state of the command in the user interface.

		/// </param>

		/// <param term='commandText'>

		///		Text requested by the neededText parameter.

		/// </param>

		/// <seealso class='Exec' />

		public void QueryStatus(string commandName, EnvDTE.vsCommandStatusTextWanted neededText, ref EnvDTE.vsCommandStatus status, ref object commandText)

		{

			if(neededText == EnvDTE.vsCommandStatusTextWanted.vsCommandStatusTextWantedNone)

			{

				if(commandName == "VSNUnit2k3.Connect.VSNUnit2k3")

				{

					status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;

				}

			}

		}



		/// <summary>

		///      Implements the Exec method of the IDTCommandTarget interface.

		///      This is called when the command is invoked.

		/// </summary>

		/// <param term='commandName'>

		///		The name of the command to execute.

		/// </param>

		/// <param term='executeOption'>

		///		Describes how the command should be run.

		/// </param>

		/// <param term='varIn'>

		///		Parameters passed from the caller to the command handler.

		/// </param>

		/// <param term='varOut'>

		///		Parameters passed from the command handler to the caller.

		/// </param>

		/// <param term='handled'>

		///		Informs the caller if the command was handled or not.

		/// </param>

		/// <seealso class='Exec' />

		public void Exec(string commandName, EnvDTE.vsCommandExecOption executeOption, ref object varIn, ref object varOut, ref bool handled)

		{

			handled = false;

			if(executeOption == EnvDTE.vsCommandExecOption.vsCommandExecOptionDoDefault)

			{

				

				if(commandName == "VSNUnit2k3.Connect.VSNUnit2k3")

				{

					try

					{
				//		LoadVSNUnitAddin(true);
						LoadVSNUnitAddin();
					}
					catch(System.Runtime.InteropServices.COMException)
					{
				//		LoadVSNUnitAddin(true);
						LoadVSNUnitAddin();
					}
					catch(System.IndexOutOfRangeException)
					{
					}
					catch(Exception ex)
					{
						System.Windows.Forms.MessageBox.Show(ex.GetType().FullName + "\n" + ex.Message + "\n" + ex.StackTrace, "Error(s)...");
					}
					handled = true;
					return;
				}

			}

		}


		private void RunVSNUnitAddin(){
			if(applicationObject != null){
				applicationObject.ExecuteCommand("VSNUnit2k3.Connect.VSNUnit2k3","");
			}
		}

		private void UnLoadVSNUnitAddin(){
			if(applicationObject != null && windowToolWindow != null){
				applicationObject.MainWindow.LinkedWindows.Remove(windowToolWindow);
			}
		}

		private void GetMyConfig(){
			try
			{
				WindowConfigurations colWinConfig = applicationObject.WindowConfigurations;
				WindowConfiguration objWinConfig;
				objWinConfig = colWinConfig.Item("VSNUnit2k3");
				objWinConfig.Apply(true);
			}
			catch (Exception ex) 
			{
				
			}
		}

		private void SaveMyConfig(){
			if(isLoaded == true){			
				try	{
					WindowConfigurations colWinConfig = applicationObject.WindowConfigurations;
					WindowConfiguration objWinConfig;
					objWinConfig = colWinConfig.Add("VSNUnit2k3");
					objWinConfig.Update();
				}
				catch (Exception ex) {
				}
			}
		}

		private void LoadVSNUnitAddin()//bool isShow)
		{
			string guidstr = "{F623951C-F116-41ae-AC4B-AE4C1118ADD4}";
			object objTemp = null;
			windowToolWindow = applicationObject.Windows.CreateToolWindow(addInInstance, "VSUserControlHost.VSUserControlHostCtl", "VSNUnit2k3", guidstr, ref objTemp);
			GetMyConfig();	
			isLoaded = true;
			windowToolWindow.Visible = true;
			objControl = (VSUserControlHostLib.IVSUserControlHostCtl)objTemp;
			System.Reflection.Assembly asm = System.Reflection.Assembly.GetExecutingAssembly();
			object win = objControl.HostUserControl(asm.Location, "VSNUnit2k3.vsnunitctl");
			vsnunitctl vsnc = (vsnunitctl)win;
			vsnc.App = applicationObject;	
	
		}

		
		private _DTE applicationObject;

		private AddIn addInInstance;

		private Window windowToolWindow = null;

		private bool isLoaded = false;

		private VSUserControlHostLib.IVSUserControlHostCtl objControl;

	
	}

}